<?php

require_once dirname(dirname(__FILE__)).'/lib/perm.php';
require_once dirname(dirname(__FILE__)).'/class/gtickets.php';

$cid = isset($_POST['cid'])? intval($_POST['cid']) : 0;
$gperm_handler =& myXoopsGroupPermHandler::getInstance();
$member_handler =& xoops_gethandler('member');
$group_list =& $member_handler->getGroupList();

$gperm_config = array(
    'allow_html' => '_MD_D3DIARY_PERMDESC_ALLOW_HTML',
    'allow_regdate' => '_MD_D3DIARY_PERMDESC_ALLOW_REGDATE'
);


// module ID 
$module_handler =& xoops_gethandler('module');
$this_module =& $module_handler->getByDirname($mydirname);
$mid = $this_module->getVar('mid');
$mod_name = $this_module->getVar('name');

// renew group permissions
if(!empty( $_POST['gperm_renew'])) {
    if ( ! $xoopsGTicket->check( true , 'd3diary_admin' ) ) {
        redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
    }

    // delete once
    $criteria = new CriteriaCompo( new criteria('gperm_modid', $mid ) );
    $criteria->add( new criteria('gperm_itemid', $cid) );
    $gperm_handler->deletes($criteria);
    
    $cid=0;
    // And renew
    foreach(array_keys($group_list) as $gid ) {
        foreach(array_keys($gperm_config) as $gperm_name) {
            if(!empty($_POST[$gperm_name][$gid])) {
                $gperm_row = array(
                    'gperm_item_id' => $cid,
                    'gperm_modid'   => $mid,
                    'gperm_groupid' => intval($gid),
                    'gperm_name'    =>  addslashes($gperm_name)  
                );
                $gperm =& $gperm_handler->create();
                $gperm->assignVars($gperm_row);
                $gperm->setDirty();
                if(!$gperm_handler->insert($gperm)) {
                    redirect_header(XOOPS_URL.'/modules/'.$mydirname.'/admin/index.php?page=permission', 2, _MD_D3DIARY_MESSAGE_DBUPDATE_FAILED);
                    exit();
                }
                unset($gperm);
            }
        }        
    }
    
    redirect_header( XOOPS_URL.'/modules/'.$mydirname.'/admin/index.php?page=permission&amp;cid='.$cid, 1, _MD_D3DIARY_MESSAGE_DBUPDATE_SUCCESS ) ;
    exit ;
}

// get permission by group_id
$gperms = myPerm::getPermsByGroup();
$groupperm = array();     // array by category id, extensible for future
foreach( $group_list as $gid=>$gname ) {
    $gid = intval($gid);
    $gname = htmlspecialchars($gname, ENT_QUOTES);
    $groupperm[$cid][$gid] = array();
    $groupperm[$cid][$gid]['gid'] = $gid;
    $groupperm[$cid][$gid]['gname'] = $gname;
    $groupperm[$cid][$gid]['perms'] = array();
    foreach(array_keys($gperm_config) as $gperm_name) {
        if(isset($gperms[$cid][$gid][$gperm_name]))
            $groupperm[$cid][$gid]['perms'][$gperm_name] = 1;
        else
            $groupperm[$cid][$gid]['perms'][$gperm_name] = 0;
    }
}      
    
xoops_cp_header();
include dirname(__FILE__).'/mymenu.php' ;
$tpl = new XoopsTpl() ;
$tpl->assign( array(
    'mydirname' => $mydirname,
    'mod_url' => sprintf("%s/modules/%s", XOOPS_URL, $mydirname),
    'myname' => $mod_name,
    'modConfig' => $xoopsModuleConfig,
    'cid' => $cid ,
    'category_name' => _MD_D3DIARY_LANG_CATEGORY_GLOBAL,
    'gperm_config' => $gperm_config,
    'groupperms' => $groupperm,
    'group_list' => $group_list,
    'gticket_hidden' => $xoopsGTicket->getTicketHtml( __LINE__ , 1800 , 'd3diary_admin') ,
) ) ;
$tpl->display( 'db:'.$mydirname.'_admin_permission.html' ) ;
xoops_cp_footer();

?>