<?php

//--------------------------------------------------------------------
// Config
//--------------------------------------------------------------------

include_once dirname( dirname(__FILE__) ).'/class/category.class.php';
$category =& Category::getInstance();
$myts =& MyTextSanitizer::getInstance();

//--------------------------------------------------------------------
// GET Initial Valuses
//--------------------------------------------------------------------

$myname = "editcategory.php";

if(is_object($xoopsUser)) {
	$uid = $xoopsUser->getVar('uid');
	$uname = $xoopsUser->getVar('uname');
} else {
    redirect_header(XOOPS_URL.'/user.php',2,_MD_IVUID_ERR);
	exit();
}

// dort /rename / add / delete --> non nategory 

$common_cat=d3diary_getpost_param('common_cat') ? intval(d3diary_getpost_param('common_cat')) : 0 ;
// uid overrides for common category
if ($common_cat==1){
	$category->uid=0;
} else {
	$category->uid=$uid;
}
$category->cid=intval(d3diary_getpost_param('cid'));

// define Template
$xoopsOption['template_main']= $mydirname.'_editcategory.html';
include XOOPS_ROOT_PATH."/header.php";
// this page uses smarty template
// this must be set before including main header.php

$xoopsTpl->assign("yd_uid", $uid);
$xoopsTpl->assign("yd_uname", $uname);
$xoopsTpl->assign("yd_isadmin", d3diary_check_isadmin($mydirname, $uid));	// added 2010-5-6
$xoopsTpl->assign("yd_use_open_cat", intval($xoopsModuleConfig['use_open_cat']));

// edit
if(!empty($_POST['editsub']) and $category->cid>0){
	$category->readdb($mydirname);
	$category->cname= d3diary_getpost_param('cname');
	if(empty($category->cname)){
		redirect_header("editcategory.php",2,_MD_CATEGORY_NONAME);exit();
	}
	$category->updatedb($mydirname);
	redirect_header("index.php?page=editcategory",2,_MD_CATEGORY_UPDATED);

// create
}elseif(!empty($_POST['createsub'])){
	$category->cname= d3diary_getpost_param('cname');
	if(empty($category->cname)){
		redirect_header("index.php?page=editcategory",2,_MD_CATEGORY_NONAME);exit();
	}
	$category->insertdb($mydirname, $common_cat);
	redirect_header("index.php?page=editcategory",2,_MD_CATEGORY_CREATED);

// delete
}elseif(!empty($_POST['delsub'])){
	$category->deletedb($mydirname);
	
	// update blogs
	if ($common_cat==1){
		$sql = "UPDATE ".$xoopsDB->prefix($mydirname.'_diary')." SET cid='0'
			WHERE cid='".$category->cid."'";
	} else {
		$sql = "UPDATE ".$xoopsDB->prefix($mydirname.'_diary')." SET cid='0'
			WHERE uid='".$uid."' and cid='".$category->cid."'";
	}
	$result = $xoopsDB->query($sql);

	redirect_header("index.php?page=editcategory",2,_MD_CATEGORY_DELETED);

// swap
}elseif(!empty($_POST['swapsub'])){
	$cid1=d3diary_getpost_param('cid1');
	$cid2=d3diary_getpost_param('cid2');
	
	$category->cid=$cid1;
	$category->readdb($mydirname);
	if(empty($category->cname)){
		redirect_header("index.php?page=editcategory",2,_MD_IVCID);exit();
	}
	$corder1=$category->corder;
	
	$category->cid=$cid2;
	$category->readdb($mydirname);
	if(empty($category->cname)){
		redirect_header("index.php?page=editcategory",2,_MD_IVCID);exit();
	}
	$corder2=$category->corder;
	
	// update
	$category->corder=$corder1;
	$category->updatedb($mydirname);

	$category->cid=$cid1;
	$category->readdb($mydirname);
	$category->corder=$corder2;
	$category->updatedb($mydirname);
	
	redirect_header("index.php?page=editcategory",2,_MD_CATEGORY_SWAPPED);

// input form
}else{
	d3diary_assign_category_foredit2($mydirname);
}


function d3diary_assign_category_foredit2($mydirname){
	global $uid, $myts, $xoopsDB, $xoopsTpl;
	
	$yd_category = array();
	$yd_common_cat = array();

	$sql = "SELECT * FROM ".$xoopsDB->prefix($mydirname.'_category')."
	          WHERE uid=".intval($uid)." ORDER BY corder";

	$result = $xoopsDB->query($sql);

	$i=0;
	while ( $dbdat = $xoopsDB->fetchArray($result) ) {
		if($i>0){
			$yd_category[$i]['cid_before']   = $yd_category[$i-1]['cid'];
			$yd_category[$i-1]['cid_after']   = $dbdat['cid'];
		}
		$yd_category[$i]['cid']   = $dbdat['cid'];
		$yd_category[$i]['cname']   = $myts->makeTboxData4Show($dbdat['cname']);
		$yd_category[$i]['corder']   = $dbdat['corder'];
		$yd_category[$i]['blogtype']   = $dbdat['blogtype'];
		$yd_category[$i]['blogurl']   = $dbdat['blogurl'];
		$yd_category[$i]['rss']   = $dbdat['rss'];
		$yd_category[$i]['openarea']   = $dbdat['openarea'];
		$yd_category[$i]['dohtml']   = $dbdat['dohtml'];
		$i++;
	}
	$xoopsTpl->assign("yd_category", $yd_category);
	$xoopsTpl->assign("mydirname", $mydirname);

	$sql = "SELECT * FROM ".$xoopsDB->prefix($mydirname.'_category')."
	          WHERE uid='0' ORDER BY corder";

	$result = $xoopsDB->query($sql);

	$i=0;
	while ( $dbdat = $xoopsDB->fetchArray($result) ) {
		if($i>0){
			$yd_common_cat[$i]['cid_before']   = $yd_common_cat[$i-1]['cid'];
			$yd_common_cat[$i-1]['cid_after']   = $dbdat['cid'];
		}
		$yd_common_cat[$i]['cid']   = $dbdat['cid'];
		$yd_common_cat[$i]['cname']   = $myts->makeTboxData4Show($dbdat['cname']);
		$yd_common_cat[$i]['corder']   = $dbdat['corder'];
		$yd_common_cat[$i]['blogtype']   = $dbdat['blogtype'];
		$yd_common_cat[$i]['blogurl']   = $dbdat['blogurl'];
		$yd_common_cat[$i]['rss']   = $dbdat['rss'];
		$yd_common_cat[$i]['openarea']   = $dbdat['openarea'];
		$yd_common_cat[$i]['dohtml']   = $dbdat['dohtml'];
		$i++;
	}
	$xoopsTpl->assign("yd_common_cat", $yd_common_cat);
}


include_once XOOPS_ROOT_PATH.'/footer.php';

?>
